#ifndef _IDTABLE_H_
#define _IDTABLE_H_

#define IDMAX  	 	65535 
#define NAMESIZE    	8
#define SIMPLE          32 
#define NAMELENGTH      32

#define INVALID         65535

typedef struct {
   unsigned short  ID; 
   char            name[NAMELENGTH];
   char            type;
   void *          next;
   /* 'e' :element
      'a' :attribute
      'o' :other */
}IDRecord;

typedef struct {
    unsigned short ID[NAMESIZE];
    void *	   next;		
}NameRecord;

class IDTable {
   
   private: 
      IDRecord		* ID_Table ; 
      NameRecord	* Name_Table;
      
      unsigned short    id_rate;   // how many bucket in IDtable.
      unsigned short    name_rate; // how many char index needed
      unsigned short 	IDCounter;
   
      bool simple_getID(char *, unsigned short &);
      int  getNameBucketEntry(char *name);
      void insertInNameTable(char *name, unsigned short id);
      
   public:
     IDTable(unsigned short ID_bucket_rate=10, 
             unsigned short Name_bucket_rate= 2) ;
     ~IDTable();
   
     unsigned short  insertElement(char *, char);

     bool getID(char *,unsigned short &);
     bool getName(unsigned short, char *);
     
     void dump();
};

#endif
