/**
 * Util.h
 * Author: Yuan Wang
 * Implementation of set of file names.
 */


#define FIRST_SIZE 100
#define SECOND_SIZE 100


/**
 * FileNameVector
 */
class FileNameVector
{
public:

  /**
   * Constructor.
   */
  FileNameVector ();

  /**
   * Destructor.
   */
  ~FileNameVector ();

  /**
   * Add a file name.
   * @param fileName  file name
   * @return file id
   */
  int addFileName ( char* fileName );

  /**
   * Get the file name by its id.
   * @param fid  file id
   * @return file name
   */
  char* getFileName ( int fid );


private:

  char*** names;
  int firstIndex, secondIndex;
};
