#include "buffervector.h"
#include "constant.h"
#include <stdio.h>
#define INITSIZE	100

BufferVector::BufferVector(int unitSize) {

	maxSize=INITSIZE;
	size=0;
	this->unitSize=unitSize;
	buffer=new char[unitSize*maxSize];
}

BufferVector::~BufferVector() {
	if(size==0) delete [] buffer;
}

void BufferVector::deleteBuffer() {
	delete [] buffer;
}

void BufferVector::addValue(char* buf) {
	memcpy(buffer+size*unitSize, buf, unitSize);
	size++;
	if(size>=maxSize) {
		char* temp;
		maxSize+=INITSIZE;
		temp=buffer;
		buffer=new char[maxSize*unitSize];
		memcpy(buffer, temp, size*unitSize);
		delete [] temp;
	}
}

void BufferVector::addValues(char* buf, int recordCount) {
	int tag=0;
	while(maxSize<=size+recordCount) {
		maxSize+=INITSIZE;
		tag=1;
	}
	if(tag==1) {
		char* temp;
		temp=buffer;
		buffer=new char[maxSize*unitSize];
		memcpy(buffer, temp, size*unitSize);
		delete [] temp;
	}
	memcpy(buffer+size*unitSize, buf, recordCount*unitSize);
	size+=recordCount;
}

char* BufferVector::getBuffer() {
	return buffer;
}

char* BufferVector::getElement(int no) {
	if(no<size) {
		char* temp=new char[unitSize];
		memcpy(temp, buffer+no*unitSize, unitSize);
		return temp;
	}
	return NULL;
}

int BufferVector::getSize() {
	return size;
}
