#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "constant.h"
#include "head.h"
#include "buildbtree.h"
#include "node.h"
#include "runfile.h"

BuildBTree::BuildBTree(char key_type, int key_size, int other_field_len, char* prefix) {
	assert(other_field_len==(sizeof(int)+sizeof(ushort))*2);
	key_len=key_size;
	this->key_type=key_type; 
	this->other_field_len=other_field_len;
	filename_prefix=new char[strlen(prefix)+1];
	strcpy(filename_prefix, prefix);
	currentLeaf=new Node(LEAFNODE, key_type, key_size, 2*sizeof(int)+sizeof(ushort), filename_prefix);
	currentEntry=new Node(ENTRYNODE, key_type, other_field_len, 0,  filename_prefix);
	root=NULL;
}

BuildBTree::~BuildBTree() {
	delete [] filename_prefix;
	delete currentLeaf;
	delete currentEntry;
}

int BuildBTree::addToEntry(char* data) { // add to entry node
	return currentEntry->addToEntry(data);
}

int BuildBTree::getFileNum() {
	return currentEntry->getFileNum();
}

int BuildBTree::getOffset() {
	return currentEntry->getOffset();
}

void BuildBTree::addToLeaf(char* data, char* key) {
	currentLeaf->addToLeaf(data, key);
/*
	if(currentLeaf->addData(data, key)==0) {
		// no enough space left
		// write current leaf to file,
		// new another currentleaf
		// modify father;

		currentLeaf->outToFile();
		
		if(root==NULL) {
			root=new Node(OTHERNODE, key_type, key_len, sizeof(int),filename_prefix);
			root->addData(currentLeaf->getFileNum());  // not leaf
			currentLeaf->setFather(root);
		}
		currentLeaf->reset();
		currentLeaf->addData(data, key);

		currentLeaf->getFather()->addData(key,currentLeaf->getFileNum());  //not leaf
	}
*/
}


void BuildBTree::finish() {
	Node* temp;
	currentEntry->outToFile();
	while(currentLeaf!=NULL) {
		temp=currentLeaf;
		currentLeaf=currentLeaf->getFather();
		if(currentLeaf==NULL) {
			temp->setFileNumZero();
		}
		temp->outToFile();
		delete temp;
	}
}
		
