#ifndef __DIRLAYER__
#define __DIRLAYER__

#include "predit.h"
#include "FileStore.h"
#include "RecordStore.h"

class DirLayer {
	public:
		friend class DirPool;
		DirLayer(DirLayer* f, Predit* p=NULL, char* buf=NULL);
		~DirLayer();

		void setPredit(Predit* p);
		void setFather(DirLayer* f);
		void execCmd();
		void dumpResult();
		void setSon(DirLayer* p) { son=p;} ;
		void showResult();
	private:
		DirLayer* father;
		DirLayer* son;
		Predit* pp;
		// the format of result is:  fid1, eid1, fid2, eid2, ....
		char* result;
		int length;
		char* buffer;

		//void getInitResult(Predit* p, char*& result, int& length);
		void getFatherResult(char*& fatherResult, int& fatherLen);
		void getResult(char*& rr, int& len);
		void getPreditResult(Predit* p, char nextType, char* fatherResult,
								int fatherLen);
		void merge(char* buf1, int len1, char* buf2, int len2, 
							char*& result, int& length);
		void interSect(char* buf1, int len1, char* buf2, int len2,
							char*& result, int& length); 
};

#endif
