
#include "dirlayer.h"
#include "dirpool.h"
#include "query.h"
#include "runfile.h"
#include <iostream.h>
#include <stdio.h>
#include <sys/time.h>

#define TIME_DEBUG		1

DirPool::DirPool() {

	head=new DirLayer(NULL, NULL, NULL);
	currentLayer=head;
/*
	recordStore=rs;
	fileStore=fs;
*/
}

DirPool::~DirPool() {
	DirLayer* temp;
	while(head!=NULL) {
		temp=head->son;
		delete head;
		head=temp;
	}
}

void DirPool::release(DirLayer* temp) {
	DirLayer* tt;
	while(temp!=NULL) {
		tt=temp->son;
		delete temp;
		temp=tt;
	}
}

void DirPool::addLayer(DirLayer* d) {
	d->setFather(currentLayer);
	currentLayer->setSon(d);
	currentLayer=d;
}

void DirPool::execCmd(char* command) {
	struct timeval tval1, tval2;
	if(TIME_DEBUG) {
		RunFile::setTimeZero();
		PageStore::initTime();
		gettimeofday(&tval1, 0);
	}

	if(strcmp(command, "ls")==0) {
		if(currentLayer!=head) {
			currentLayer->showResult();
		}
		else {
			cout<<"this is top level"<<endl;
		}
	}
	else if(strcmp(command, "cd")==0) {
		currentLayer=head;
	}
	else if(strcmp(command, "cd ..")==0) {
		if(currentLayer!=head) {
			cout<<"to next layer"<<endl;
			currentLayer=currentLayer->father;
			//if(currentLayer!=head) currentLayer->showResult();
		}
	}
	else {
		int tag;
		Query* query=new Query(command, tag);
		if(tag==1) {
			return;
		}
		DirLayer* temp=currentLayer->son;
		if(temp!=NULL&&(strcmp(query->getBuffer(),  temp->buffer)==0)) {
			cout<<"already exist"<<endl;
			currentLayer=currentLayer->son;
			//currentLayer->showResult();
		}
		else {
			DirLayer* dirLayer=new DirLayer(currentLayer, 
					query->getPredit(), query->getBuffer());
			delete query;
			currentLayer=dirLayer;
			currentLayer->execCmd();
			release(temp);
		}
	}
	if(TIME_DEBUG) {
		gettimeofday(&tval2, 0);
		cout<<"The search takes time:";
		cout<<(tval2.tv_sec-tval1.tv_sec)*1000000+
				tval2.tv_usec-tval1.tv_usec<<endl;
		PageStore::showTime();
		RunFile::printTime();
		
	}
}
