#include <stdio.h>
#include <string.h>

#include "FileStore.h"
#include "RecordStore.h"
#include "dirpool.h"
#include "sort.h"
#include "constant.h"

#define SORTFIELDNUM		1

RecordStore* DirPool::recordStore =  new RecordStore();
FileStore* DirPool::fileStore   =  new FileStore();

int main(){
   int size;
   Location *loc;
   
   char * eName;
   char * content;
   
/*
   RecordStore* DirPool::recordStore =  new RecordStore();
   FileStore* DirPool::fileStore   =  new FileStore();
*/

//------------by weishen
	char* fieldType;
	int* fieldSize;
	char** prefix;

	fieldType=new char[SORTFIELDNUM];
	fieldSize=new int[SORTFIELDNUM];
	prefix=new char*[SORTFIELDNUM];
	prefix[0]=new char[6];

	fieldType[0]=STRINGTYPE;
	fieldSize[0]=6;
	strcpy(prefix[0], "year");

	Sort* sort=new Sort(SORTFIELDNUM, fieldType, fieldSize, prefix, 3);
//--------------end
   char* TContent=new char[7];
	strcpy(TContent,"title");
	TContent[6]='\0';
   for (int j=0;j<60;j++){
      
      int yuanFid = j/10;
      int yuanEid = j%10;
      
      eName  = new char [strlen("improcessing")+1];
      strcpy(eName,"improcessing"); 
      DirPool::recordStore->createRecord(eName,yuanFid,yuanEid);
      delete [] eName;
      
      eName  = strdup("key");
      content = strdup("conf_sigmod_Mylopoulos80");
      DirPool::recordStore->addAttribute(1,eName,content);
      free(eName);
      free(content);
      ////////////////////////
      DirPool::recordStore->goToNextLevel();
      eName = strdup("author");
      DirPool::recordStore->createElement(eName);
      free(eName);

      content = strdup("John Mylopoulos");
      DirPool::recordStore->addElementContent(content);
      free(content);
      
      DirPool::recordStore->finishElement();
      //////////////////////////////////
      eName = strdup("title");
      DirPool::recordStore->createElement(eName);
      free(eName);

		TContent[5]=random() %10+'0';
      DirPool::recordStore->addElementContent(TContent);

	cout<<"No.:"<<j<<" yuanFid:"<<yuanFid<<" yuanEid:"<<yuanEid<<" Title:"
				<<TContent;
      
      DirPool::recordStore->finishElement();

      //////////////////////////////////
      eName = strdup("pages");
      DirPool::recordStore->createElement(eName);
      free(eName);

      content = strdup("5-12");
      DirPool::recordStore->addElementContent(content);
      free(content);
      
      DirPool::recordStore->finishElement();

      ////////////////////////////////////////
      eName = strdup("year");
      DirPool::recordStore->createElement(eName);
      free(eName);

// create out of order here.
int rand_year = (yuanFid*10 +yuanEid) % 20;
char st_year[6];
for(int i=0; i<6; ++i) st_year[i]='\0';
sprintf(st_year,"%d",rand_year);
//printf("%s\n",st_year);

		cout<<" year:"<<st_year<<endl;
      content = strdup(st_year);
      DirPool::recordStore->addElementContent(content);
      free(content);
       
      DirPool::recordStore->finishElement();

      ////////////////////////////////////////

      ////////////////////////////////////////
      eName = strdup("booktitle");
      DirPool::recordStore->createElement(eName);
      free(eName);

      content = strdup("Workshop on Data Abstraction, Databases and Conceptual Modelling");
      DirPool::recordStore->addElementContent(content);
      free(content);
       
      DirPool::recordStore->finishElement();

      ////////////////////////////////////////

      eName = strdup("url");
      DirPool::recordStore->createElement(eName);
      free(eName);

      content = strdup("db/conf/sigmod/pingree80.html#Mylopoulos80");
      DirPool::recordStore->addElementContent(content);
      free(content);
       
      DirPool::recordStore->finishElement();

      ////////////////////////////////////////

      DirPool::recordStore->finishThisLevel();

      char * st =DirPool::recordStore->finishRecord(size);
///////////////////////////////////////////////////////////////
// dump out the record
/*
      printf("size = %d\n",size);
if (j==0){
      for (int i=0;i<size;i++) {
         printf("%d ",(int)st[i]);
         if ((i+1)%15==0) printf("\n");
      }
      printf("\n");
}
      char * path[2] ={"improcessing","year"};
      char ** result;
      int count;

      DirPool::recordStore->loadValue(st,size, path,1 ,result,count);
      printf(" find %d result\n",count);
      for (int i=0;i<count;i++) printf("%s\n",result[i]);

      for (int i=0;i<count;i++) delete [] result[i];
      delete [] result;*/


      int fid;
      unsigned short rid;
      DirPool::fileStore->insertRecord(st, (unsigned short)size, fid, rid);
//printf("insert in : %d %d\n",fid,rid);  

//-------------add by wei shen
		ushort oldEid=yuanEid;
		sort->insertRecord(0, yuanFid, oldEid, fid, rid, st_year);

//---------------end

      // delete record
      delete [] st;
   }
	delete [] TContent;

//--------------add by wei shen
	sort->Run();
	delete sort;
	delete [] fieldType;
	delete [] fieldSize;
	delete [] prefix[0];
	delete [] prefix;

/*
	cout<<"**********************  Test 1 ******************************"<<endl;
	DirPool* dirPool=new DirPool();
	dirPool->execCmd("cd title=\"title9\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool;
	cout<<"**********************  Test 2 ******************************"<<endl;
	DirPool* dirPool1=new DirPool();
	dirPool1->execCmd("cd year=\"1\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool1;
	cout<<"**********************  Test 3 ******************************"<<endl;
	DirPool* dirPool2=new DirPool();
	dirPool2->execCmd("cd title=\"title9\"&&year=\"1\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool2;
	cout<<"**********************  Test 4 ******************************"<<endl;
	DirPool* dirPool3=new DirPool();
	dirPool3->execCmd("cd year=\"1\"&&title=\"title9\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool3;
	cout<<"**********************  Test 5 ******************************"<<endl;
	DirPool* dirPool3=new DirPool();
	dirPool3->execCmd("cd year=\"1\"&&year=\"9\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool3;
	cout<<"**********************  Test 6 ******************************"<<endl;
	DirPool* dirPool4=new DirPool();
	dirPool4->execCmd("cd year=\"1\"||year=\"9\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool4;
*/
	cout<<"**********************  Test 7 ******************************"<<endl;
	DirPool* dirPool2=new DirPool();
	dirPool2->execCmd("cd title=\"title9\"&&title=\"title4\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool2;
	cout<<"**********************  Test 8 ******************************"<<endl;
	DirPool* dirPool3=new DirPool();
	dirPool3->execCmd("cd title=\"title4\"&&title=\"title9\"\n");

	cout<<endl;
	cout<<endl;
	cout<<endl;
	delete dirPool3;

   delete DirPool::recordStore;
   delete DirPool::fileStore;
   return 0;
}
