#include "head.h"
#include "constant.h"
#include "searchbtree.h"
#include "searchnode.h"
#include <sys/types.h>
#include <sys/stat.h>


SearchBTree::SearchBTree(char* prefix, char& tag) {
	struct stat buf;
	int temp=strlen(prefix);
	this->prefix=new char[temp+1];
	strcpy(this->prefix, prefix);
	rootFileName=new char[temp+3];
	strcpy(rootFileName, prefix);
	rootFileName[temp]='_';
	rootFileName[temp+1]='0';
	rootFileName[temp+2]='\0';
	tag=stat(rootFileName, &buf);
	
}

SearchBTree::~SearchBTree() {
	delete [] prefix;
	delete [] rootFileName;
}

void SearchBTree::search(char* key, int op, int*& fids, ushort*& eids, 
				int*& wfids, ushort*& weids, int&length) {
	root=new SearchNode(rootFileName,prefix);
	root->searchBT(key, op, fids, eids, wfids, weids, length);
	delete root;
	return;
}


void SearchBTree::search(char* key, int op, char*& buf, int& length) {
	root=new SearchNode(rootFileName,prefix);
	root->searchBT(key, op, buf, length);
	delete root;
	return;
}
